static void mbtk_glfw_clipboard_set(mbtk_display_t *disp, const char *new_content)
{
	glfw_win_t *gw = (glfw_win_t *)disp->topwin;

	if (disp->topwin == NULL) {
		mbtk_error("mbtk_glfw_clipboard_set() requires a top window\n");
		return;
	}
	glfwSetClipboardString(gw->window, new_content);
}

static char *mbtk_glfw_clipboard_get(mbtk_display_t *disp)
{
	glfw_win_t *gw = (glfw_win_t *)disp->topwin;
	const char *res;

	if (disp->topwin == NULL) {
		mbtk_error("mbtk_glfw_clipboard_get() requires a top window\n");
		return NULL;
	}

	res = glfwGetClipboardString(gw->window);
	return (res == NULL) ? NULL : mbtk_strdup(res);
}

static void mbtk_glfw_clipboard_free(mbtk_display_t *disp, char *str_got)
{
	free(str_got);
}

