#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <libmbtk/backend.h>
#include <libmbtk/util.h>
#include <genvector/vtp0.h>
#include <libmbtk/src_3rd/genht/htip.h>
#include "../common/fdwatch.h"
#include "../common/monotime.h"

typedef struct xlib_win_s {
	Window window;
	GC gc;
	XFontStruct *fnt;
	int last_w, last_h, last_x, last_y;
	unsigned sub:1; /* set if window is a sub-window */
	unsigned skip_render:1; /* do not render anything in this window (caller will render) */
} xlib_win_t;

typedef struct xlib_display_s {
	Display *display;
	int screen, depth;
	Visual *visual;
	int fd;
	Colormap cmap;
	vtp0_t fonts;     /* key: mbtk_font_id_t.l; value: (XFontStruct *) or NULL */
	htip_t id2win;    /* map X window ID to (xlib_win_t *) */
	struct {          /* cache atom lookup by name */
		Atom wmdel, wmactw;
		Atom wm_hints, wintype, wtype_dialog, wtype_ddmenu, wtype_pumenu;
		Atom wtype_menu, wtype_combo, wtype_ttip, wmst_modal, wmstate;
		Atom clipboard, selection, utf8_str, comp_str, targets, savetargets;
		Atom null, mult, pair;
	} xa;
	struct {          /* cache key codes for modifiers */
		KeyCode lshift, rshift;
		KeyCode lctrl, rctrl;
		KeyCode lalt, ralt;
	} xk;
	mbtk_watch_fd_t watch;
	double base_time;
	char *clipboard;
} xlib_display_t;
