#ifndef LIBMBTK_DEBUG_INLINES_H
#define LIBMBTK_DEBUG_INLINES_H

/* API: Calls useful for debugging the hvbox layout  */

#include <libmbtk/config.h>
#include <stdio.h>
#include <libmbtk/src_3rd/genhvbox/hvbox_debug.h>

/* name is not copied or free'd */
MBTK_INLINE void mbtk_dbg_widget_set_name(mbtk_widget_t *w, const char *name);

/* Print the hvbox tree of the whole window w is in */
MBTK_INLINE void mbtk_dbg_widget_dump_tree(FILE *dst, mbtk_widget_t *w);

/* Print the hvbox subtree starting from w */
MBTK_INLINE void mbtk_dbg_widget_dump_subtree(FILE *dst, mbtk_widget_t *w);

/*** Implementation ***/

MBTK_INLINE void mbtk_dbg_widget_set_name(mbtk_widget_t *w, const char *name)
{
	w->hvbox.widget = (char *)name;
}

MBTK_INLINE void mbtk_dbg_widget_dump_tree(FILE *dst, mbtk_widget_t *w)
{
	mbtk_window_t *win = w->win;
	hvbox_dump_nodes(dst, 0, win->root, 1);
}

MBTK_INLINE void mbtk_dbg_widget_dump_subtree(FILE *dst, mbtk_widget_t *w)
{
	hvbox_dump_nodes(dst, 0, &w->hvbox, 1);
}

#endif
