#ifndef LIBMBTK_KEYSYM_H
#define LIBMBTK_KEYSYM_H

/* API: key symbols (portable names for keycodes) */

typedef enum mbtk_keymod_e { /* bitfield */
	MBTK_KM_SHIFT = 1,
	MBTK_KM_ALT = 2,
	MBTK_KM_CTRL = 4,
	MBTK_KM_KEYPAD = 8    /* pressed on the keymap */
} mbtk_keymod_t;

typedef enum mbtk_keysym_e {
	MBTK_KS_INVALID = 0,  /* failed to decode */

	/* values between 32 and 127 are ASCII, not defined here */

	/* values below 32 are invalid, except for these: */
	MBTK_KS_BACKSPACE = 8,
	MBTK_KS_TAB = 9,
	MBTK_KS_ENTER = 10, /* for both \r and \n */
	MBTK_KS_ESC = 27,

	/* F1..Fx: use MBTK_KS_FN + x where x <= 255; so F1 is MBTK_KS_FN+1 (F0 is not used) */
	MBTK_KS_FN = 0xF000,

	/* Cursor */
	MBTK_KS_HOME = 0xF100,   /* also begin */
	MBTK_KS_END,
	MBTK_KS_LEFT,
	MBTK_KS_RIGHT,
	MBTK_KS_UP,
	MBTK_KS_DOWN,
	MBTK_KS_PGUP,           /* also prior */
	MBTK_KS_PGDN,           /* also next */

	/* Modifiers */
	MBTK_KS_SHIFT_L = 0xF200,
	MBTK_KS_SHIFT_R,
	MBTK_KS_ALT_L,
	MBTK_KS_ALT_R,
	MBTK_KS_CTRL_L,
	MBTK_KS_CTRL_R,

	/* Random extra keys */
	MBTK_KS_DEL = 0xFF00,
	MBTK_KS_INS
} mbtk_keysym_t;

#endif
