#define MBTK_NO_INCLUDE_WIDGETS
#include <libmbtk/widget.h>
#include <libmbtk/widget_imp.h>
#include <libmbtk/widget/Common.h>


int mbtk_comm_frame_fallback_minsize(mbtk_widget_t *w, long *mx, long *my)
{
	long l, r, t, b;
	mbtk_window_t *win = w->win;
	const mbtk_style_t *style = mbtk_widget_style(w);
	mbtk_styleprop_t *sp = mbtk_styleprop_get(w);

	style->min_box_frame_size(win, sp, w->flags, &l, &r, &t, &b);

	w->hvbox.fr_l = l; w->hvbox.fr_r = r;
	w->hvbox.fr_t = t; w->hvbox.fr_b = b;
	*mx = l+r; *my = t+b;

	return 0;
}

void mbtk_comm_frame_fallback_draw(mbtk_widget_t *w)
{
	mbtk_window_t *win = w->win;
	const mbtk_style_t *style = mbtk_widget_style(w);
	mbtk_styleprop_t *sp = mbtk_styleprop_get(w);

	style->draw_bg_rect(win, sp, w->flags, w->hvbox.x, w->hvbox.y, w->hvbox.w, w->hvbox.h);
	style->draw_box_frame(win, sp, w->flags, w->hvbox.x, w->hvbox.y, w->hvbox.w, w->hvbox.h);
}

void mbtk_comm_frame_fallback_draw_overlay(mbtk_widget_t *w)
{
	mbtk_window_t *win = w->win;
	const mbtk_style_t *style = mbtk_widget_style(w);
	mbtk_styleprop_t *sp = mbtk_styleprop_get(w);

	style->draw_box_overlay(win, sp, w->flags, w->hvbox.x, w->hvbox.y, w->hvbox.w, w->hvbox.h);
}

mbtk_widget_t *mbtk_comm_embed1_set_child(mbtk_widget_t *parent, mbtk_widget_t *w)
{
	mbtk_widget_t *res = NULL;

	if (parent->hvbox.ch_first != NULL) {
		res = (mbtk_widget_t *)parent->hvbox.ch_first;
		mbtk_widget_unembed((mbtk_widget_t *)parent->hvbox.ch_first);
	}
	hvbox_append_existing_box(&parent->hvbox, &w->hvbox);

	/* for the case parent button is already added */
	mbtk_widget_embedded(parent, w);
	return res;
}

mbtk_widget_t *mbtk_comm_embed_replace(mbtk_widget_t *host, mbtk_widget_t *old, mbtk_widget_t *new)
{
	mbtk_widget_t *parent = (mbtk_widget_t *)old->hvbox.parent;
	hvbox_append_existing_box_at(&old->hvbox, &new->hvbox);
	mbtk_widget_unembed(old);
	mbtk_widget_embedded(parent, new);
	return old;
}

