#ifndef LIBMBTK_WIDGET_PROGBAR_H
#define LIBMBTK_WIDGET_PROGBAR_H

#include <libmbtk/config.h>
#include <libmbtk/widget.h>
#include <libmbtk/widget_inlines.h>

/* Button: can be clicked a mouse click release or enter release */
typedef struct mbtk_progbar_s {
	mbtk_widget_t w;
	double min, max;
	double curr;        /* interpreted only between min and max (value copied and clamped) */
} mbtk_progbar_t;

/* Create a new progress bar with min/max set to 0/1, curr set to 0. */
mbtk_progbar_t *mbtk_progbar_new(mbtk_progbar_t *caller_alloced);

/* Set curr value of prg. If curr is between min and max, inclusive, it is
set. If curr is out of range and clamp is true, it is clamped and set. Else
error is returned. Returns 0 on success, -1 on error. */
int mbtk_progbar_set_curr(mbtk_progbar_t *prg, double curr, int clamp);

MBTK_WIDGET_INLINES(progbar)

#endif
