#ifndef LIBMBTK_WIDGET_FLAGS_H
#define LIBMBTK_WIDGET_FLAGS_H

/* API: flags that any widget should support */

typedef struct mbtk_widget_flags_s {
	/* widget states supported by all widgets: user accessible */
	unsigned disabled:1;        /* won't react to user input or focus */
	unsigned activated:1;       /* e.g. push button pushed, checkbox ticked */
	unsigned focus:1;
	/* hide is tracked in hvbox->hidden */

	/* widget states supported by all widgets: internal */
	unsigned dirty:1;           /* set to 1 if redraw is required */
	unsigned caller_alloced:1;  /* 1 if caller supplied the storage and mbtk_widget_destroy() won't free it */
	unsigned created:1;         /* 1 if the widget is created, 0 if it is already destroyed */

	unsigned focus_pref:8;      /* preference on the focus - when a new layout is created and the default focus needs to be determined; higher value is more preferred; 0 means the widget doesn't want to get focused */

} mbtk_widget_flags_t;

#endif
